; 65c816 opcodes 0x20-0x2F:
;    20: JSR a       3,6
;    21: ORA (d,x)   2,6
;    22: JSL al      4,8
;    23: AND d,s     2,4
;    24: BIT d       2,3
;    25: AND d       2,3
;    26: ROL d       2,5
;    27: AND [d]     2,6
;    28: PLP s       1,4
;    29: AND #       2,2
;    2A: ROL A       1,2
;    2B: PLD s       1,5
;    2C: BIT a       3,4
;    2D: AND a       3,4
;    2E: ROL a       3,6
;    2F: AND al      4,5

; 20

ALIGNC
E0_JSR_a:
 GET_PC eax
 add eax,byte 2      ; last instruction byte PC in ax
 E0_PUSH_W           ; Address of last byte not next instruction (huh!)
 ADDR_Absolute_JMP

 mov ebx,B_PB_Shifted
 mov R_NativePC,eax
 or eax,ebx

 shr eax,13
 mov eax,[_Read_Bank8Offset+eax*4]
 test eax,eax
 jnz .read_direct

 xor ebx,ebx
 mov eax,_Blank     ;we should really trap this...
.read_direct:
 add eax,ebx

 add R_NativePC,eax
 mov B_PBOffset,eax

 jmp near CPU_RETURN

ALIGNC
E1_JSR_a:
 GET_PC eax
 add eax,byte 2      ; last instruction byte PC in ax
 E1_PUSH_W           ; Address of last byte not next instruction (huh!)
 ADDR_Absolute_JMP

 mov ebx,B_PB_Shifted
 mov R_NativePC,eax
 or eax,ebx

 shr eax,13
 mov eax,[_Read_Bank8Offset+eax*4]
 test eax,eax
 jnz .read_direct

 xor ebx,ebx
 mov eax,_Blank     ;we should really trap this...
.read_direct:
 add eax,ebx

 add R_NativePC,eax
 mov B_PBOffset,eax

 jmp near CPU_RETURN

; 21
EM_AND Od_xO,Direct_Indexed_Indirect
E0_AND Od_xO,Direct_Indexed_Indirect

; 22

ALIGNC
E0_JSL_al:              ; JSR Absolute long address
 mov al,B_PB
 E0_PUSH_B              ; Push PB
 GET_PC eax
 add eax,byte 3         ; Address of last byte of instruction
 E0_PUSH_W              ; Push PC

 mov al,[1+R_NativePC]
 xor ebx,ebx
 mov ah,[2+R_NativePC]
 mov bl,[3+R_NativePC]
 mov B_PB,bl
 mov R_NativePC,eax
 test [MEMSEL],bl       ; Check bus speed against PB
 mov al,5
 jnz .fastrom
 mov al,4
.fastrom:
 mov [CycleTable],al    ; Update bus speed
 mov edi,R_NativePC
 shl ebx,16
 or edi,ebx

 shr edi,13
 mov edi,[_Read_Bank8Offset+edi*4]
 test edi,edi
 jnz .read_direct

 xor ebx,ebx
 mov edi,_Blank     ;we should really trap this...
.read_direct:
 add edi,ebx

 add R_NativePC,edi
 mov B_PBOffset,edi

 jmp near CPU_RETURN

ALIGNC
E1_JSL_al:
 mov al,B_PB
 E1_PUSH_B           ; Push PB
 GET_PC eax
 add eax,byte 3         ; Address of last byte of instruction
 E1_PUSH_W              ; Push PC

 mov al,[1+R_NativePC]
 xor ebx,ebx
 mov ah,[2+R_NativePC]
 mov bl,[3+R_NativePC]
 mov B_PB,bl
 mov R_NativePC,eax
 test [MEMSEL],bl       ; Check bus speed against PB
 mov al,5
 jnz .fastrom
 mov al,4
.fastrom:
 mov [CycleTable],al    ; Update bus speed
 mov edi,R_NativePC
 shl ebx,16
 or edi,ebx

 shr edi,13
 mov edi,[_Read_Bank8Offset+edi*4]
 test edi,edi
 jnz .read_direct

 xor ebx,ebx
 mov edi,_Blank     ;we should really trap this...
.read_direct:
 add edi,ebx

 add R_NativePC,edi
 mov B_PBOffset,edi

 jmp near CPU_RETURN

; 23
EM_AND d_s,Stack_Relative
E0_AND d_s,Stack_Relative

; 24
EM_BIT d,Direct
E0_BIT d,Direct

; 25
EM_AND d,Direct
E0_AND d,Direct

; 26
EM_ROL d,Direct
E0_ROL d,Direct

; 27
EM_AND IdI,Direct_Indirect_Long
E0_AND IdI,Direct_Indirect_Long

; 28

ALIGNC
E0_PLP:
 inc R_NativePC
 E0_PULL_B
 E0_RESTOREFLAGS

 JUMP_FLAG SNES_FLAG_I,.no_irq
 mov al,[IRQ_pin]
 test al,al
 jz .no_irq
 SAVE_PC ebx
 add R_Cycles,byte 60   ; IRQ processing: 2 IO + 6 bank0
 call E0_IRQ
 LOAD_PC
.no_irq:
 SET_TABLE_MX
ALIGNC
E1_PLP:
 inc R_NativePC
 E1_PULL_B
 E1_RESTOREFLAGS

 JUMP_FLAG SNES_FLAG_I,CPU_RETURN,near
 mov al,[IRQ_pin]
 test al,al
 jz near CPU_RETURN
 SAVE_PC ebx
 add R_Cycles,byte 52   ; IRQ processing: 2 IO + 5 bank0
 call E1_IRQ
 LOAD_PC
 jmp near CPU_RETURN

; 29
EM_AND i,Immediate
E0_AND i,Immediate

; 2A

ALIGNC
EM_RLA:
 inc R_NativePC
 mov eax,B_A
 MAKE_CARRY
 adc al,al
 mov B_A,al
 STORE_FLAGS SNES_FLAG_NZC
 jmp near CPU_RETURN

ALIGNC
E0_RLA:
 inc R_NativePC
 mov eax,B_A
 MAKE_CARRY
 adc ax,ax
 mov B_A,eax
 STORE_FLAGS SNES_FLAG_NZC
 jmp near CPU_RETURN

; 2B

ALIGNC
E0_PLD:
 inc R_NativePC
 E0_PULL_W
 mov B_D,eax
;test ax,ax
 shl eax,16
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN
ALIGNC
E1_PLD:
 inc R_NativePC
 E1_PULL_W
 mov B_D,eax
;test ax,ax
 shl eax,16
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN

; 2C
EM_BIT a,Absolute
E0_BIT a,Absolute

; 2D
EM_AND a,Absolute
E0_AND a,Absolute

; 2E
EM_ROL a,Absolute
E0_ROL a,Absolute

; 2F
EM_AND al,Absolute_Long
E0_AND al,Absolute_Long
