%ifndef SNEeSe_SPC_i
%define SNEeSe_SPC_i

%define VAR_CYCLE_RATIO

%include "regs.ni"

;%1 = SaveCycles
%macro Execute_SPC 0-1 0
 pusha
%ifidni %1,SaveCycles
 cmp byte [CPU_Executing],0
 mov eax,R_65c816_Cycles
 jnz %%in_cpu
 mov eax,[_SNES_Cycles]
%%in_cpu:
 ; Update CPU and SPC cycles
 mov edi,[SPC_last_cycles]
 mov [SPC_last_cycles],eax
 sub eax,edi
 add eax,[SPC_CPU_cycles]
%endif

%if 0
 65c816 runs at 189e7 / 88 masterclock. SPC runs at 2048000 clock.
 HOWEVER we only see 1320/1360 of that...
 Optimal conversion factors...

     10.178509880513       10:1
     61.07105928307799     61:6
    173.034667968721      173:17
    458.0329446230847     458:45
    743.0312212774497     743:73
   1028.029497931815     1028:101
   1313.02777458618      1313:129
   1598.026051240546     1598:157
   1883.024327894911     1883:185
   2168.022604549276     2168:213
   2453.020881203642     2453:241
   2738.019157858007     2738:269
   3023.017434512372     3023:297
   3308.015711166738     3308:325
   3593.013987821103     3593:353
   3878.012264475468     3878:381
   4163.010541129834     4163:409
   4448.008817784199     4448:437
   4733.007094438564     4733:465
   5018.00537109293      5018:493
   5303.003647747295     5303:521
   5588.00192440166      5588:549
   5873.000201056026     5873:577
  53142.00008615461     53142:5221
 153553.000057439      153553:15086
%endif

%ifdef VAR_CYCLE_RATIO
%ifdef SPC_CYCLES_DIV_BEFORE_MUL
 xor edx,edx
 mov edi,[_SPC_CPU_cycle_divisor]
 div edi
 mov edi,[_SPC_CPU_cycle_multiplicand]
 mov [SPC_CPU_cycles],edx   ; Save remainder
 mul edi
%else
 mov edi,[_SPC_CPU_cycle_multiplicand]
 mul edi
 mov edi,[_SPC_CPU_cycle_divisor]
 add eax,[SPC_CPU_cycles_mul]
 adc edx,byte 0
 div edi
 xor edi,edi
 mov [SPC_CPU_cycles_mul],edx   ; Save remainder
 mov [SPC_CPU_cycles],edi
%endif
%else
%if 0
 ; 32:3 - 10.667 : 1
 mov ecx,eax                ; We don't want to lose cycles..
 and eax,byte (~31)
 shr eax,5                  ; Divide by 32
 and ecx,byte 31
 lea eax,[eax+eax*2]        ; Multiply by 3
 mov [SPC_CPU_cycles],ecx   ; Save remainder
%endif
 ; 61:6 - 10.1666.. : 1
 xor edx,edx
 mov edi,61
 div edi
 lea eax,[eax+eax*2]        ; Multiply by 3
 mov [SPC_CPU_cycles],edx   ; Save remainder
 add eax,eax    ; *6

%if 0
 ; 71:7 - 10.14285714.. : 1 (is it 1320/1364?)
 xor edx,edx
 mov edi,71
 div edi
 mov edi,eax
 lea eax,[eax*8]            ; Multiply by 8
 mov [SPC_CPU_cycles],edx   ; Save remainder
 sub eax,edi    ; *7
%endif
%endif
 add eax,[_SPC_Cycles]      ; Add new balance of SPC cycles
 mov [_SPC_Cycles],eax
 cmp [_TotalCycles],eax
 jb %%need_execute
 ; Check for and handle 35-minute wrap
 test eax,eax
 js %%no_cycles
 cmp dword [_TotalCycles],byte 0
 jns %%no_cycles
 call _Wrap_SPC_Cyclecounter
%%need_execute:
 call _SPC_START
%%no_cycles:
 popa
%endmacro

%endif ; SNEeSe_SPC_i
