; SPC700 opcodes 0x20-0x2F:
;    20: CLRP            1,2
;    21: TCALL 2         1,8
;    22: SET1 dp.1       2,4
;    23: BBS dp.1,rel    3,5/7
;    24: AND A,dp        2,3
;    25: AND A,labs      3,4
;    26: AND A,(X)       1,3
;    27: AND A,(dp+X)    2,6
;    28: AND A,#imm      2,2
;    29: AND dp(d),dp(s) 3,6
;    2A: OR1 C,/mem.bit  3,5
;    2B: ROL dp          2,4
;    2C: ROL labs        3,5
;    2D: PUSH A          1,4
;    2E: CBNE dp,rel     3,5/7
;    2F: BRA rel         2,4
;

; 20
ALIGNC
SPC_CLRP:
 inc R_NativePC
 CLR_FLAG_SPC SPC_FLAG_P
 mov byte [SPC_PAGE+1],0
 jmp SPC_BACK

; 21
TCALL 2
; 22 - SPC_SET1 in SPCmain.S
; 23 - SPC_BBS in SPCmain.S
; 24
SPC_AND_A dp
; 25
SPC_AND_A abs
; 26
SPC_AND_A OXO
; 27
SPC_AND_A OOdp_XOO
; 28
ALIGNC
SPC_AND_A_IM:
 SPC_OP_A_IM AND,SPC_FLAG_NZ

; 29
SPC_AND_mem dp_dp
; 2A
ALIGNC
SPC_OR1C:       ; Carry flag = Carry flag OR !mem.bit
 ADDR_membit    ; bx contains mem and dx contains bit number
 GET_BYTE_SPC   ; Get byte at location
 bt eax,edx
 LOAD_BASE
 jc near SPC_BACK        ; C | ~1 = C
 SET_FLAG_SPC (SPC_FLAG_C)  ; C | ~0 = 1
 jmp SPC_BACK

; 2B
SPC_ROL dp
; 2C
SPC_ROL abs
; 2D
SPC_PUSH_reg A
; 2E
ALIGNC
SPC_CBNE_dp:
 mov ebx,B_SPC_PAGE
 mov bl,[1+R_NativePC]  ; get dp
 GET_BYTE_SPC           ; get (dp)
 cmp B_A,al
 je .not_taken
 movsx eax,byte [2+R_NativePC]  ; sign extend for addition
 add R_Cycles,byte 2    ; Branch taken
 add R_NativePC,eax
;add dword [_TotalCycles],byte 2    ; (0.32) Butcha - fix 'lost' SPC timer ticks!
.not_taken:
 add R_NativePC,byte 3
 jmp SPC_BACK

; 2F
ALIGNC
SPC_BRA:
 movsx eax,byte [1+R_NativePC]  ; sign extend for addition
 add R_NativePC,byte 2
 add R_NativePC,eax
 jmp SPC_BACK
