; SPC700 opcodes 0x60-0x6F:
;    60: CLRC            1,2
;    61: TCALL 6         1,8
;    62: SET1 dp.3       2,4
;    63: BBS dp.3,rel    3,5/7
;    64: CMP A,dp        2,3
;    65: CMP A,labs      3,4
;    66: CMP A,(X)       1,3
;    67: CMP A,(dp+X)    2,6
;    68: CMP A,#imm      2,2
;    69: CMP dp(d),dp(s) 3,6
;    6A: AND1 C,/mem.bit 3,4
;    6B: ROR dp          2,4
;    6C: ROR labs        3,5
;    6D: PUSH Y          1,4
;    6E: DBNZ dp,rel     3,5/7
;    6F: RET             1,5
;

; 60
ALIGNC
SPC_CLRC:
 inc R_NativePC
 CLR_FLAG_SPC SPC_FLAG_C
 jmp SPC_BACK

; 61
TCALL 6
; 62 - SPC_SET1 in SPCmain.S
; 63 - SPC_BBS in SPCmain.S
; 64
SPC_CMP_A dp
; 65
SPC_CMP_A abs
; 66
SPC_CMP_A OXO
; 67
SPC_CMP_A OOdp_XOO
; 68
ALIGNC
SPC_CMP_A_IM:
 SPC_OP_A_IM CMP,SPC_FLAG_NZC

; 69
SPC_CMP_mem dp_dp
; 6A
ALIGNC
SPC_AND1C:      ; Carry flag = Carry flag AND !mem.bit
 ADDR_membit    ; bx contains mem and dx contains bit number
 GET_BYTE_SPC   ; Get byte at location
 bt eax,edx
 LOAD_BASE
 jnc near SPC_BACK       ; C & ~0 = C
 CLR_FLAG_SPC SPC_FLAG_C    ; C & ~1 = 0
 jmp SPC_BACK

; 6B
SPC_ROR dp
; 6C
SPC_ROR abs
; 6D
SPC_PUSH_reg Y
; 6E
ALIGNC
SPC_DBNZ_dp:
 mov ebx,B_SPC_PAGE
 mov bl,[1+R_NativePC]  ; get dp
 GET_BYTE_SPC           ; get (dp)
 dec eax
 SET_BYTE_SPC
 test al,al
 jz .not_taken
 movsx eax,byte [2+R_NativePC]  ; sign extend for addition
 add R_Cycles,byte 2    ; Branch taken
 add R_NativePC,eax
;add dword [_TotalCycles],byte 2    ; (0.32) Butcha - fix 'lost' SPC timer ticks!
.not_taken:
 add R_NativePC,byte 3
 jmp SPC_BACK

; 6F
ALIGNC
SPC_RET:
 POP_W
 cmp eax,0xFFC0
 mov R_NativePC,eax
 mov eax,[SPC_FFC0_Address]
 jnb .possible_rom
 mov eax,_SPCRAM
.possible_rom:
 add R_NativePC,eax
 mov B_SPC_Code_Base,eax
 jmp SPC_BACK
