#ifndef SNEeSe_types_h
#define SNEeSe_types_h

#include <dir.h>
#include "font.h"
#include "wrapaleg.h"

#define cBorder_Back 0
#define cBorder_Fore 7
#define cMenu_Back cWindow_Back
#define cMenu_Fore 0
#define cSelected_Back 0
#define cSelected_Fore 7
#define cText_Back cWindow_Back
#define cText_Fore 0
#define cWindow_Back 7

extern "C" unsigned char *GUI_Screen;

// hidden func in Allegro - hope this doesn't botch compatibility later!
extern "C" BITMAP *_make_bitmap(int w, int h, unsigned long addr, GFX_DRIVER *driver, int color_depth, int bpl);

struct SCREEN {
 int depth,w_base,h_base,w,h,driver;
 void (*adjust)(void);
 int set(){
  int error;
  set_color_depth(depth);
  error=set_gfx_mode(driver, w_base, h_base, w_base, h_base);
  if(error) return error;
  if(w_base != w || h_base != h){
   switch(driver){
    case GFX_MODEX:
    case GFX_VGA:
     (*adjust)();
     break;

    default:
     /* Size adjustment not supported */
     break;
   }
  }
  return 0;
 }
};

typedef SCREEN * pSCREEN;

typedef struct {
 char drive[MAXDRIVE],dir[MAXDIR],file[MAXFILE],ext[MAXEXT];
} fname;

inline void fnmerge(char *path,fname *n){
 fnmerge(path, n->drive, n->dir, n->file, n->ext);
}

inline void fnsplit(char *path,fname *n){
 fnsplit(path, n->drive, n->dir, n->file, n->ext);
}

#endif /* SNEeSe_types_h */
